/*
 *  QTPlay.h
 *  4D Plugin
 *
 *  Created by Thomas on 22.05.05.
 *  Modified by Louis on 25.03.2006
 *
 *  Copyright 2005 4D GmbH. All rights reserved.
 *
 */

#ifndef _TM_QTHANDLING_
#define _TM_QTHANDLING_

#include "4DPluginAPI.h"

#if VERSIONWIN
	#include <Windows.h>
	#include <stdlib.h>
	#include <malloc.h>
	#include <memory.h>
	#include <strsafe.h>
	#include "QTML.h"
	#include "Movies.h"
	#include "MacMemory.h"
	#include "Endian.h"
	#include "GXMath.h"
	#include "Gestalt.h"
#else
	#include <Carbon/Carbon.h>
	#include <QuickTime/QuickTime.h>

#endif

const UInt8 kUserDataIsText = 0xA9; // the copyright symbol

// 25.3.06 Louis Thoumin
// Define few error codes 
#if VERSIONWIN
	#define noErr				0 // Defined on MacOS
#endif
#define kErr_InvalidPath	-10
#define kErr_MemError		-108
#define	kErr_BadKindArea	-11
#define	kErr_MovieNotClosed	-12

// --------------------------------------

// --- QTControlCommands
/*
#define QTPlay			1
#define QTStep			2
#define QTGoto			3
#define QTVolume		4
#define QTController	5
#define QTVolumeIcon	6
#define QTStepIcon		7
#define QTSpeed			8
#define	QTGetLength		9
#define QTLoop			10
#define QTSize			11
#define QTGetTimeScale	12
#define QTGetMovieWidth	13
#define QTGetMovieHeight	14
#define QTSelectionStart	15
#define QTSelectionLength	16
#define QTPlaySelection	17
#define QTEditSelection	18
*/
enum {
	QTPlay						= 1,
	QTStep						,
	QTGoto						,
	QTVolume					,
	QTController				,
	QTVolumeIcon				,
	QTStepIcon					,
	QTSpeed						,
	QTGetLength					,
	QTLoop						,
	QTSize						,
	QTGetTimeScale				,
	QTGetMovieWidth				,
	QTGetMovieHeight			,
	QTSelectionStart			,
	QTSelectionLength			,
	QTPlaySelection				,
	QTEditSelection				,
	QTGetMoviePreferredRate		,
	QTGetMoviePreferredVolume
};


enum {
	kNormalLooping					= 0,
	kPalindromeLooping				= 1,
	kNoLooping						= 2
};


#if __NextVersion__
typedef struct{
	long	DisplaySize;
	long	loop;
	short	HideController;
	short	HideVolume;
	short	HideStep;
	short	AllowEdit;
	short	PlaySelection;
}MovieProps;
#endif

typedef struct{
	long			Tag;
	char*			filename;
	Movie			theMovie;
	MovieController theMC;
	Boolean			movieOpened;
	Boolean			IsMovie;
	short			DoJob;	
	short			FormPage;
	long			DisplaySize;
	Rect			CurMovieBox;
#if __NextVersion__
	MovieProps		*AdvancedProps;
#endif
#if VERSIONWIN	
	HWND			FormWindow;
	HDC				fWinHDC;
#else
	ControlRef		MovieControl;
	CWindowPtr		FormWindow;
	CGrafPtr		fMacPort;
#endif
	short			IsExternalAreaInForm;	// 05.04.2006 LT
											// True if this area is visible in a form
											// False if this area is created through QT_NewOffscreenArea
}MovieStuff;

	Boolean QTUtils_IsImageFile (FSSpec *theFSSpec);
	OSErr QTUtils_GetMovieFileLoopingInfo (Movie theMovie, long *theLoopInfo);
	void QTUtils_SetLoopingState (Movie theMovie, MovieController theMC, long 	myLoopInfo);
	void QTSetMovieBox(MovieStuff*	gMovieStuff, Rect TheAreaRect);
	void TestMyDialog(void);

	long build_FSSpecFrompath ( char* thePath, FSSpec *myFSSpec);

#endif