/*
 *  QTPlayExtern.h
 *  declares routines and variables to be used from outside
 *
 *  Created by Thomas on 22.05.05.
 *  Modified by Louis on 25.03.2006
 *
 *  Copyright 2005 4D GmbH. All rights reserved.
 *
 */

#ifndef _TM_QTExtern_
#define _TM_QTExtern_

#include "4DPluginAPI.h"// Louis 25.3.06 Should be here

#if VERSIONWIN
	#include <Windows.h>
#else
	#include <Carbon/Carbon.h>
	#include <QuickTime/QuickTime.h>
#endif

enum {
	kIsNotExternalArea	= 0,	// 05.04.2006 Louis Thoumin
	kIsExternalArea		= 1		// 05.04.2006 Louis Thoumin
};


#ifdef __cplusplus
extern "C" {
#endif 
	
	void QT_Init(void);
	void QT_DeInit(void);

	void QTArea_Init(PA_PluginParameters params , short kindOfArea); // 05.04.2006 Louis Thoumin Added short kindOfArea
	void QTArea_PreInit(PA_PluginParameters params , short kindOfArea); // 05.04.2006 Louis Thoumin Added short kindOfArea
	void QTArea_DeInit(void * myPtr);

	long PlayFileWithQuickTime (char * pfad, long len);
	void StopPlayFileWithQuickTime(void);

	long QT_SetMovie (PA_PluginParameters params);
	long QT_SetControl (void * Area, long command, long value);
	long QT_GetControl (void * Area, long command, long * value);
	long QT_DoMovieJob(PA_PluginParameters params);
	long QT_DoIdle(PA_PluginParameters params);
	long QT_DoClick(PA_PluginParameters params);
	long QT_DoScroll(PA_PluginParameters params);
	long QT_PageChange(PA_PluginParameters params);

	void DesignEditButton(PA_PluginParameters params);

	void QTArea_Execution(PA_PluginParameters params);
	long QT_GetID3Tags (void * Area, PA_Variable * TagID, PA_Variable * TagContent);
	long QT_GetScreenshot(void * Area, PA_Handle * PictureShot);

	#if VERSIONWIN
		void MyPA_RectToRECT(PA_Rect areaRect, RECT *rect);
	#endif


#ifdef __cplusplus
}
#endif 


#endif